package tech.nevets.modbot.util.commands;

import net.dv8tion.jda.api.entities.User;
import net.dv8tion.jda.api.events.ReadyEvent;
import net.dv8tion.jda.api.events.interaction.SlashCommandEvent;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import net.dv8tion.jda.api.hooks.ListenerAdapter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import tech.nevets.modbot.CoreBot;
import tech.nevets.modbot.api.commands.CommandRegistry;

import javax.annotation.Nonnull;

public class CoreListener extends ListenerAdapter {
    private static final Logger LOGGER = LoggerFactory.getLogger(CoreListener.class);
    private final CommandRegistry registry = new CommandRegistry();

    {
        registry.addCommand(new HelpCmd());
        registry.addCommand(new TestCmd());
        CommandManager.addFromRegistry(registry);
    }

    public CommandRegistry getCommandRegistry() {
        return registry;
    }

    @Override
    public void onReady(@Nonnull ReadyEvent event) {
        LOGGER.info("BuzzBot is ready: " + event.getJDA().getSelfUser().getAsTag());
    }

    @Override
    public void onGuildMessageReceived(@Nonnull GuildMessageReceivedEvent event) {
        User user = event.getAuthor();
        String raw = event.getMessage().getContentRaw();

        if (user.isBot() || event.isWebhookMessage()) {
            return;
        }

        if (raw.startsWith(CoreBot.CORE_CONFIG.getConfig().getString("bot.prefix"))) {
            registry.handle(event);
        }
    }

    @Override
    public void onSlashCommand(@Nonnull SlashCommandEvent event) {
        registry.handle(event);
    }
}
